/******/ (() => { // webpackBootstrap
var __webpack_exports__ = {};
navigator.serviceWorker.getRegistrations().then(function (registrations) {
  for (let registration of registrations) {
    registration.unregister();
  }
});

// https://developers.google.com/web/tools/workbox/guides/troubleshoot-and-debug
importScripts('https://storage.googleapis.com/workbox-cdn/releases/5.0.0-beta.1/workbox-sw.js');

// Install newest
// https://developers.google.com/web/tools/workbox/modules/workbox-core
workbox.core.skipWaiting();
workbox.core.clientsClaim();

// Cache static assets that aren't precached
workbox.routing.registerRoute(/\.(?:js|css|json5)$/, new workbox.strategies.StaleWhileRevalidate({
  cacheName: 'static-resources'
}));

// Cache the Google Fonts stylesheets with a stale-while-revalidate strategy.
workbox.routing.registerRoute(/^https:\/\/fonts\.googleapis\.com/, new workbox.strategies.StaleWhileRevalidate({
  cacheName: 'google-fonts-stylesheets'
}));

// Cache the underlying font files with a cache-first strategy for 1 year.
workbox.routing.registerRoute(/^https:\/\/fonts\.gstatic\.com/, new workbox.strategies.CacheFirst({
  cacheName: 'google-fonts-webfonts',
  plugins: [new workbox.cacheableResponse.CacheableResponsePlugin({
    statuses: [0, 200]
  }), new workbox.expiration.ExpirationPlugin({
    maxAgeSeconds: 60 * 60 * 24 * 365,
    // 1 Year
    maxEntries: 30
  })]
}));

// MESSAGE HANDLER
self.addEventListener('message', event => {
  if (event.data && event.data.type === 'SKIP_WAITING') {
    switch (event.data.type) {
      case 'SKIP_WAITING':
        // TODO: We'll eventually want this to be user prompted
        // workbox.core.skipWaiting();
        // workbox.core.clientsClaim();
        // TODO: Global notification to indicate incoming reload
        break;
      default:
        console.warn(`SW: Invalid message type: ${event.data.type}`);
    }
  }
});
workbox.precaching.precacheAndRoute([{'revision':null,'url':'./109.bundle.b4fee2a22b622839baf5.js'},{'revision':null,'url':'./117.bundle.17ae130d2bb21ef9d31f.js'},{'revision':null,'url':'./121.bundle.27d181784f24551bc546.js'},{'revision':null,'url':'./141.bundle.556b4c1e4cab770417ac.js'},{'revision':null,'url':'./164.bundle.e30009bee13acb6967da.js'},{'revision':null,'url':'./17dd54813d5acc10bf8f.wasm'},{'revision':'d32549aa3716d55d525e59e31e2f6591','url':'./20fc4c659b85ccd2a9c0.wasm'},{'revision':null,'url':'./236.bundle.79a374f5fdf7fde431f4.js'},{'revision':null,'url':'./243.bundle.0f584aed3f7b90162277.js'},{'revision':null,'url':'./295.bundle.c935ed0430aa026f7591.js'},{'revision':null,'url':'./297.bundle.194d8985ab974839b5b6.js'},{'revision':null,'url':'./325.bundle.a0a3768652fdfb82e7fd.js'},{'revision':'51b8ed55f5b8d448837222f03bdd6de8','url':'./325.css'},{'revision':null,'url':'./342.bundle.17f0c50a27c0ba1f3846.js'},{'revision':'c4ea120c6da08aa75348edfa3e57ece9','url':'./36785fbd89b0e17f6099.wasm'},{'revision':null,'url':'./370.bundle.e4cd6c20d3496c949374.js'},{'revision':null,'url':'./445.bundle.38c6d2af64e41cd7c614.js'},{'revision':null,'url':'./448.bundle.8229be08c3e7cb41cc3d.js'},{'revision':'51b8ed55f5b8d448837222f03bdd6de8','url':'./481.css'},{'revision':null,'url':'./483.bundle.016de3c3ec209d9fa42a.js'},{'revision':null,'url':'./487.bundle.3cb5573c4f321ab6a469.js'},{'revision':'c377e1f5fe4a207d270c3f7a8dd3e3ca','url':'./5004fdc02f329ce53b69.wasm'},{'revision':null,'url':'./501.bundle.de519580f8ba42802378.js'},{'revision':null,'url':'./530.bundle.17b9a34fefff133e5379.js'},{'revision':null,'url':'./544.bundle.170c67e76a6900a9a644.js'},{'revision':'0afb25509c7f072fbd7eda42c6895dbf','url':'./544.css'},{'revision':null,'url':'./545.bundle.f3cce08abe3d1dba5abd.js'},{'revision':null,'url':'./550.bundle.3103d75ed38bebd6dc6f.js'},{'revision':'185e5e0a10fa6ab2fc7b3c38e63d550b','url':'./550.css'},{'revision':null,'url':'./574.bundle.b369b11b04c3e080f0b3.js'},{'revision':'a04a2f233dc569826f5f6e21b65bc87b','url':'./574.css'},{'revision':'62b4ae8445d191d5aab5503ce475724d','url':'./610.min.worker.js'},{'revision':'3c2206525c18cd87dd28082949a4e43e','url':'./610.min.worker.js.map'},{'revision':'5800265b6831396572fb5d32c6bd8eef','url':'./62ab5d58a2bea7b5a1dc.wasm'},{'revision':null,'url':'./644.bundle.1e77691d2eeb96a423b0.js'},{'revision':'ce10eced3ce34e663d86569b27f5bffb','url':'./65916ef3def695744bda.wasm'},{'revision':null,'url':'./682.bundle.5a75f291795458751e7a.js'},{'revision':null,'url':'./699.bundle.8f4c86daf8730822538b.js'},{'revision':null,'url':'./702.bundle.963481fbf871984b646f.js'},{'revision':null,'url':'./721.bundle.1c1d3c54fe4feb43cc3c.js'},{'revision':null,'url':'./722.bundle.1242e0348afc63ca4f5e.js'},{'revision':null,'url':'./726.bundle.c8de818cf1a3ff0cf7d2.js'},{'revision':'cc4a3a4da4ac1b863a714f93c66c6ef2','url':'./75a0c2dfe07b824c7d21.wasm'},{'revision':null,'url':'./776.bundle.a81fa6655feba936f0bc.js'},{'revision':null,'url':'./783.bundle.7980b9f19a8dd6c758d4.js'},{'revision':null,'url':'./835.bundle.4c0eaa2c1a427ee41817.js'},{'revision':null,'url':'./862.bundle.59bb164ca7e871a33e44.js'},{'revision':null,'url':'./889.bundle.532225e4f81f4a64e65f.js'},{'revision':null,'url':'./905.bundle.a4ef442d765b599d1971.js'},{'revision':null,'url':'./907.bundle.6616607cc391fc83133e.js'},{'revision':null,'url':'./914.bundle.2b3a856b7d41ac8298e6.js'},{'revision':null,'url':'./931.bundle.d270a1fda9a2836c3cc5.js'},{'revision':null,'url':'./939.bundle.9d93b2e47c52338747a2.js'},{'revision':null,'url':'./94.bundle.7641edd39f1ec54e2978.js'},{'revision':'74c9647440e51f149ad12923d6ead952','url':'./945.min.worker.js'},{'revision':'cdf6f0457d4af2cef04fc41816241bc1','url':'./945.min.worker.js.map'},{'revision':null,'url':'./961.bundle.2dca4c5ba218ba0b3934.js'},{'revision':null,'url':'./981.bundle.982a18e3b2e777c06e04.js'},{'revision':null,'url':'./989.bundle.c34fca8a7ae865ce1971.js'},{'revision':null,'url':'./998.bundle.c8d7be41ac20dd582be9.js'},{'revision':'aa1d1f3e32367e42fe90399144d94577','url':'./998.css'},{'revision':'d1895aa7a4595dc279c382e5a31ef9f4','url':'./_headers'},{'revision':'e3bf0f3e9c34f51ad59836ae8e8eaf43','url':'./_redirects'},{'revision':'960b0d80365ca536ff24b1b10a5bd715','url':'./app-config.js'},{'revision':null,'url':'./app.bundle.04502edc4501c250f189.js'},{'revision':'218647882e809eec0f83ae6bda4eebfb','url':'./app.bundle.css'},{'revision':'cb4f64534cdf8dd88f1d7219d44490db','url':'./assets/android-chrome-144x144.png'},{'revision':'5cde390de8a619ebe55a669d2ac3effd','url':'./assets/android-chrome-192x192.png'},{'revision':'e7466a67e90471de05401e53b8fe20be','url':'./assets/android-chrome-256x256.png'},{'revision':'9bbe9b80156e930d19a4e1725aa9ddae','url':'./assets/android-chrome-36x36.png'},{'revision':'5698b2ac0c82fe06d84521fc5482df04','url':'./assets/android-chrome-384x384.png'},{'revision':'56bef3fceec344d9747f8abe9c0bba27','url':'./assets/android-chrome-48x48.png'},{'revision':'3e8b8a01290992e82c242557417b0596','url':'./assets/android-chrome-512x512.png'},{'revision':'517925e91e2ce724432d296b687d25e2','url':'./assets/android-chrome-72x72.png'},{'revision':'4c3289bc690f8519012686888e08da71','url':'./assets/android-chrome-96x96.png'},{'revision':'cf464289183184df09292f581df0fb4f','url':'./assets/apple-touch-icon-1024x1024.png'},{'revision':'0857c5282c594e4900e8b31e3bade912','url':'./assets/apple-touch-icon-114x114.png'},{'revision':'4208f41a28130a67e9392a9dfcee6011','url':'./assets/apple-touch-icon-120x120.png'},{'revision':'cb4f64534cdf8dd88f1d7219d44490db','url':'./assets/apple-touch-icon-144x144.png'},{'revision':'977d293982af7e9064ba20806b45cf35','url':'./assets/apple-touch-icon-152x152.png'},{'revision':'6de91b4d2a30600b410758405cb567b4','url':'./assets/apple-touch-icon-167x167.png'},{'revision':'87bff140e3773bd7479a620501c4aa5c','url':'./assets/apple-touch-icon-180x180.png'},{'revision':'647386c34e75f1213830ea9a38913525','url':'./assets/apple-touch-icon-57x57.png'},{'revision':'0c200fe83953738b330ea431083e7a86','url':'./assets/apple-touch-icon-60x60.png'},{'revision':'517925e91e2ce724432d296b687d25e2','url':'./assets/apple-touch-icon-72x72.png'},{'revision':'c9989a807bb18633f6dcf254b5b56124','url':'./assets/apple-touch-icon-76x76.png'},{'revision':'87bff140e3773bd7479a620501c4aa5c','url':'./assets/apple-touch-icon-precomposed.png'},{'revision':'87bff140e3773bd7479a620501c4aa5c','url':'./assets/apple-touch-icon.png'},{'revision':'05fa74ea9c1c0c3931ba96467999081d','url':'./assets/apple-touch-startup-image-1182x2208.png'},{'revision':'9e2cd03e1e6fd0520eea6846f4278018','url':'./assets/apple-touch-startup-image-1242x2148.png'},{'revision':'5591e3a1822cbc8439b99c1a40d53425','url':'./assets/apple-touch-startup-image-1496x2048.png'},{'revision':'337de578c5ca04bd7d2be19d24d83821','url':'./assets/apple-touch-startup-image-1536x2008.png'},{'revision':'cafb4ab4eafe6ef946bd229a1d88e7de','url':'./assets/apple-touch-startup-image-320x460.png'},{'revision':'d9bb9e558d729eeac5efb8be8d6111cc','url':'./assets/apple-touch-startup-image-640x1096.png'},{'revision':'038b5b02bac8b82444bf9a87602ac216','url':'./assets/apple-touch-startup-image-640x920.png'},{'revision':'2177076eb07b1d64d663d7c03268be00','url':'./assets/apple-touch-startup-image-748x1024.png'},{'revision':'4fc097443815fe92503584c4bd73c630','url':'./assets/apple-touch-startup-image-750x1294.png'},{'revision':'2e29914062dce5c5141ab47eea2fc5d9','url':'./assets/apple-touch-startup-image-768x1004.png'},{'revision':'f692ec286b3a332c17985f4ed38b1076','url':'./assets/browserconfig.xml'},{'revision':'f3d9a3b647853c45b0e132e4acd0cc4a','url':'./assets/coast-228x228.png'},{'revision':'ad6e1def5c66193d649a31474bbfe45d','url':'./assets/favicon-16x16.png'},{'revision':'84d1dcdb6cdfa55e2f46be0c80fa5698','url':'./assets/favicon-32x32.png'},{'revision':'95fb44c4998a46109e49d724c060db24','url':'./assets/favicon.ico'},{'revision':'5df2a5b0cee399ac0bc40af74ba3c2cb','url':'./assets/firefox_app_128x128.png'},{'revision':'11fd9098c4b07c8a07e1d2a1e309e046','url':'./assets/firefox_app_512x512.png'},{'revision':'27cddfc922dca3bfa27b4a00fc2f5e36','url':'./assets/firefox_app_60x60.png'},{'revision':'2547879ee2928a5fd56dca483bcbd967','url':'./assets/images/CT-AAA.png'},{'revision':'245628fb9d18d6c5cd529615079f8e86','url':'./assets/images/CT-AAA2.png'},{'revision':'997a9c8b57e7b4e46d8f01fb49d078c6','url':'./assets/images/CT-Air.png'},{'revision':'e7ed89711f63348d49898da3a2b73ab9','url':'./assets/images/CT-Bone.png'},{'revision':'09d1dc6efebb10a60cdf85ed74a10214','url':'./assets/images/CT-Bones.png'},{'revision':'f8ae9bafd3b90ba3efbdcbe8901db187','url':'./assets/images/CT-Cardiac.png'},{'revision':'ed0cc538aba90d6a1c029923ca9b47db','url':'./assets/images/CT-Cardiac2.png'},{'revision':'dfdaf4e4889aefbf09514545f45726bb','url':'./assets/images/CT-Cardiac3.png'},{'revision':'5d4b9a331136a1a5d7ce7ccf7dfcca36','url':'./assets/images/CT-Chest-Contrast-Enhanced.png'},{'revision':'5fb264499a5bb42487663b00e42d1513','url':'./assets/images/CT-Chest-Vessels.png'},{'revision':'ab8f0e569c972388ddaaa61b92449fac','url':'./assets/images/CT-Coronary-Arteries-2.png'},{'revision':'e4e7e2e3cc09bc8c4fb03b6441bd2845','url':'./assets/images/CT-Coronary-Arteries-3.png'},{'revision':'79a2962a2d3cbe4bd3b675b5ca83c659','url':'./assets/images/CT-Coronary-Arteries.png'},{'revision':'6502a6bdab1c70e2188c3bf12ce5d4e4','url':'./assets/images/CT-Cropped-Volume-Bone.png'},{'revision':'e28ad3cf5ed2006fc5a7cffd602736fc','url':'./assets/images/CT-Fat.png'},{'revision':'ca1c5be76053edee27e68ffbf9105101','url':'./assets/images/CT-Liver-Vasculature.png'},{'revision':'d6c9ab857ed2ad19f1ff20bea02b6655','url':'./assets/images/CT-Lung.png'},{'revision':'ddb599c6a163bdf28ece8de1a337470a','url':'./assets/images/CT-MIP.png'},{'revision':'0b0dcf7940a555e2a9a0900f7f84d4d3','url':'./assets/images/CT-Muscle.png'},{'revision':'6082d383f9ce375a5873e2a00fc4d372','url':'./assets/images/CT-Pulmonary-Arteries.png'},{'revision':'b317366149ee2607bec95d63eb4d7661','url':'./assets/images/CT-Soft-Tissue.png'},{'revision':'4b0cd5a673ebb71da22a91ed608d6695','url':'./assets/images/DTI-FA-Brain.png'},{'revision':'3ea1cbee022af5b94710b73726308832','url':'./assets/images/MR-Angio.png'},{'revision':'bd25ca7b166193547f34950eed440e5c','url':'./assets/images/MR-Default.png'},{'revision':'2e50a49b859aeb316a1c23f911fce9ad','url':'./assets/images/MR-MIP.png'},{'revision':'6ba74de6961e08652ff9e2f1871b473d','url':'./assets/images/MR-T2-Brain.png'},{'revision':'42406bb474f0f87cf04a5afbbcd5e389','url':'./assets/images/VolumeRendering.png'},{'revision':'2017d95fae79dcf34b5a5b52586d4763','url':'./assets/manifest.webapp'},{'revision':'cb4f64534cdf8dd88f1d7219d44490db','url':'./assets/mstile-144x144.png'},{'revision':'334895225e16a7777e45d81964725a97','url':'./assets/mstile-150x150.png'},{'revision':'e295cca4af6ed0365cf7b014d91b0e9d','url':'./assets/mstile-310x150.png'},{'revision':'cbefa8c42250e5f2443819fe2c69d91e','url':'./assets/mstile-310x310.png'},{'revision':'aa411a69df2b33a1362fa38d1257fa9d','url':'./assets/mstile-70x70.png'},{'revision':'5609af4f69e40e33471aee770ea1d802','url':'./assets/yandex-browser-50x50.png'},{'revision':'dd001f21b3970d5a7f3e245cc10d21df','url':'./assets/yandex-browser-manifest.json'},{'revision':'52b9a07fe0541fe8c313d9788550bf51','url':'./b6b803111e2d06a825bd.wasm'},{'revision':'7edb59d2be7c993050cb31ded36afa31','url':'./c22b37c3488e1d6c3aa4.wasm'},{'revision':'da9dcd774579d9c198e2eeb5ae5f8ba5','url':'./cornerstoneDICOMImageLoader.min.js'},{'revision':'408c073c4b37609508345332728cf1df','url':'./cornerstoneDICOMImageLoader.min.js.map'},{'revision':null,'url':'./dicom-microscopy-viewer.bundle.d3a56dc9f62df5e11019.js'},{'revision':'9d8c85b42d04bb117a3b583d654fbb08','url':'./dicomMicroscopyViewer.min.js'},{'revision':'450494c199cf8dd8e8c34d5e98bf5334','url':'./dicomMicroscopyViewer.min.js.LICENSE.txt'},{'revision':'4acdd19a35d759ec2669f1ba9490937d','url':'./es6-shim.min.js'},{'revision':'3f9b366dd84db03a17854a0fb6aff57d','url':'./google.js'},{'revision':null,'url':'./histogram-worker.bundle.0fc9a925b0ebe9ab0338.js'},{'revision':'36ea15475e823a7273f9778fef168276','url':'./index.html'},{'revision':'9046c04c3af284876bdd62b8052507d1','url':'./index.worker.f4bda803c15bc6359d5f.worker.js'},{'revision':'5a2e75731a97dfa37207b574921d0fff','url':'./index.worker.f4bda803c15bc6359d5f.worker.js.map'},{'revision':'71cec55513e051f0778ad89be760c11a','url':'./index.worker.min.worker.js'},{'revision':'fd1116add443fee52a935df926396e0f','url':'./index.worker.min.worker.js.map'},{'revision':'31c0367ca4160b2c6373e905739c5719','url':'./init-service-worker.js'},{'revision':'74fc9658b62903be2048c1f82a22b4d4','url':'./manifest.json'},{'revision':'3fa71aa0af3e34b4ebd9a71eee0f4bdd','url':'./ohif-logo-light.svg'},{'revision':'7e81da785c63e75650101db6c5d7560e','url':'./ohif-logo.svg'},{'revision':'eadf8bf1d85032a029e2c0df4b8938b0','url':'./oidc-client.min.js'},{'revision':null,'url':'./polySeg.bundle.a8c7d9ad4ec95198e877.js'},{'revision':'a1aef5311245f5864315443d12246c37','url':'./polyfill.min.js'},{'revision':'af9346d3e597071ba9ee8cd32f8cc0ea','url':'./serve.json'},{'revision':'b1e488d9955b62bd2858874df11d5223','url':'./silent-refresh.html'},{'revision':null,'url':'./suv-peak-worker.bundle.a07824cd66ff1fccb28f.js'}]);

// TODO: Cache API
// https://developers.google.com/web/fundamentals/instant-and-offline/web-storage/cache-api
// Store DICOMs?
// Clear Service Worker cache?
// navigator.storage.estimate().then(est => console.log(est)); (2GB?)
/******/ })()
;